package CLASSES::Alignment_Collection;
use strict;

use TOOLS::assert;
use QUERY::query_factory;
use CLASSES::Sequence_Alignment;
use CLASSES::Collection;

our @VERSION = '1.0';
our @ISA = qw(CLASSES::Collection);

#-------------------------------------------------------------------------
# Required Functions
sub _cinit {
    my $self = shift;

    return $self;
}


#################
# Name: mapping_table
# Purpose: Return the name of the table mapping the collection to the object
sub collection_type() {
    return "Sequence_Alignment";
}

sub mapping_table() {
    return "Alignment_to_Collection";
}

#-------------------------------------------------------------------------
# Extra functions
sub content_compare() {
    my ($frag1, $frag2) = ($_[1]->get_fragment(), $_[2]->get_fragment());
    my ($chr1, $chr2) = ($frag1->get_chromosome->get_number(), $frag2->get_chromosome()->get_number());
    if ($chr1 ne $chr2) {
	my ($isNum1, $isNum2) = map {$_ =~ /^\d+$/} ($chr1, $chr2);
	if ($isNum1 && $isNum2) {
	    return $chr1 <=> $chr2;
	}
	if ($isNum1) {
	    return -1;
	}
	if ($isNum2) {
	    return 1;
	}
	return $chr1 cmp $chr2;
    }

    return ($frag1->get_coords())[0]<=>($frag2->get_coords())[0] || ($frag1->get_coords())[1]<=>($frag2->get_coords())[1];
}

1;
