package CLASSES::ClassFactory;
use strict;
require Exporter;

our @ISA = qw(Exporter);
our @EXPORT = qw(create_object get_pk get);
our $VERSION = 1.00;

use CLASSES::Build;
use CLASSES::Chromosome;
use CLASSES::Chromosome_Segment;
use CLASSES::Fragment;
use CLASSES::Pseudogene;
use CLASSES::Sequence_Alignment;
use TOOLS::assert;

sub create_object {
    my %params = @_;
    my $class = $params{"class"};
    delete $params{"class"};
    $class = "CLASSES\:\:$class";
    return $class->new(%params);
}

sub get_pk {
    my $class = "CLASSES\:\:".shift;
    return $class->get_pk(@_);
}

sub get {
    my %params = @_;
    my $class = $params{"class"};
    delete $params{"class"};
    $class = "CLASSES\:\:$class";
    return $class->get(%params);
}
