package DB::Cache;
our $VERSON = '1.0';
use strict;

my %cache = ();

sub set {
    shift if ($_[0] eq "DB::Cache");

    (ref($_[0]) eq "DBI::db") or die("DB::Cache::set: First parameter must be database handle\n");
    (@_==4) or die("DB::Cache::set: Bad parameters\n");

    $cache{$_[0]} = {} unless exists($cache{$_[0]});
    $cache{$_[0]}{$_[1]} = {} unless exists($cache{$_[0]}{$_[1]});
    $cache{$_[0]}{$_[1]}{$_[2]} = $_[3];
}

sub get {
    shift if ($_[0] eq "DB::Cache");

    (@_==3) or die("DB::Cache::get: Bad parameters\n");
    (ref($_[0]) eq "DBI::db") or die("First parameter must be database handle\n");

    if (has($_[0], $_[1], $_[2])) {
	return $cache{$_[0]}{$_[1]}{$_[2]};
    }
    return undef;
}

sub has {
    shift if ($_[0] eq "DB::Cache");

    (@_==3) or die("DB::Cache::has: Bad parameters\n");
    (ref($_[0]) eq "DBI::db") or die("First parameter must be database handle\n");

    return exists($cache{$_[0]}) && exists($cache{$_[0]}{$_[1]}) && exists($cache{$_[0]}{$_[1]}{$_[2]});
}

sub remove {
    shift if ($_[0] eq "DB::Cache");

    (@_==3) or die("DB::Cache::remove: Bad parameters\n");
    (ref($_[0]) eq "DBI::db") or die("First parameter must be database handle\n");

    delete $cache{$_[0]}{$_[1]}{$_[2]};
}

1;
