package DB::db;
our $VERSON = '1.0';

use strict;
use DBI;
use DB::Mysql;

my %_defaults = ("server" => "localhost", "username" => "root", "passwd" => "", "PrintError" => 1, "RaiseError" => 1);

# Params: Hash with server, db, username and passwd fields.
sub getDB {
    my %params = @_;
    my $server = $params{"server"} || $_defaults{"server"};
    my $db = $params{"db"} or die("DB::db::getDB No database provided\n");
    my $username = $params{"username"} || $_defaults{"username"};
    my $passwd = $params{"passwd"} || $_defaults{"passwd"};
    my $PrintError = $params{"PrintError"} || $_defaults{"PrintError"};
    my $RaiseError = $params{"RaiseError"} || $_defaults{"RaiseError"};

    my $dsn = "DBI:mysql:database=$db;host=$server;port=3306";
#    return DBI->connect("dbi:mysql:$db:$server", $username, $passwd, {"PrintError" => $PrintError, "RaiseError" => $RaiseError});

    return DBI->connect($dsn, $username, $passwd, {"PrintError" => $PrintError, "RaiseError" => $RaiseError});
}

sub get_pk_value {
    my $dbh = shift or die("DB::db::get_pk_value needs a Database Handel\n");
    ref($dbh) eq "DBI::db" or die("DB::db::get_pk_value not given a database handel\n");

    return DB::Mysql->new()->get_pk_value($dbh);
}

1;
