#!/usr/bin/perl

use strict;
use DB::db;

=header
create table PFSet_Pseudogene_Extensions(
	_PFSet_id int(11) not null,
	_att_name varchar(40) not null,
	primary key (_PFSet_id, _att_name)
);
=cut

my $tax_id = $ARGV[0] or die "[program] tax_id\n";
my $dbh = DB::db::getDB(db => "Pgenes_$tax_id");

my $sth = $dbh->prepare("select _PFSet_ID, _Pgene_ID from PFSet_to_Pgene");
my $sth2 = $dbh->prepare("select _pgene_id, _att_name from Pseudogene_Extensions");
my $sth3 = $dbh->prepare("insert into PFSet_Pseudogene_Extensions values (?,?)");

my %set;
my %pgenes;
$sth2->execute();
while (my ($pgene, $att) = $sth2->fetchrow_array){
	push @{$pgenes{$pgene}}, $att;
}

$sth->execute();
while (my ($PFSet, $pgene) = $sth->fetchrow_array){
	next if not defined $pgenes{$pgene};
	my @array = @{$pgenes{$pgene}};
	foreach my $ele(@array){
		$set{$PFSet}{$ele} = 1;
	}
}

foreach my $PFSet(keys %set){
	if (not defined $set{$PFSet}){print "SET:$PFSet No Attribute\n"; next;}
	my @array = keys %{$set{$PFSet}};
	foreach my $ele(@array){
		print "SET-ID:$PFSet ATT:$ele\n";
		$sth3->execute($PFSet, $ele);
	}
}
