package QUERY::Cache;
our $VERSON = '1.0';
use strict;
use TOOLS::assert;
use QUERY::query_factory;

my %cache = ();

sub set {
    shift;
    my $dbh = assert_dbh(shift);
    my ($class, $name, $value) = @_;    
    assert($value, "value not set in ".((caller(1))[3]));

    $cache{$dbh} = {} unless exists($cache{$dbh});
    $cache{$dbh}{$class} = {} unless exists($cache{$dbh}{$class});
    $cache{$dbh}{$class}{$name} = $value;
}

sub get {
    shift;
    my $dbh = assert_dbh(shift);
    my ($class, $name) = @_;

    if (QUERY::Cache->has($dbh, $class, $name)) {
	return $cache{$dbh}{$class}{$name};
    }
    return undef;
}

sub has {
    shift;
    my $dbh = assert_dbh(shift);
    my ($class, $name) = @_;
    return exists($cache{$dbh}) && exists($cache{$dbh}{$class}) && exists($cache{$dbh}{$class}{$name});
}

sub remove {
    shift;
    my $dbh = assert_dbh(shift);
    my ($class, $name) = @_; 

    delete $cache{$dbh}{$class}{$name} if has($dbh, $class, $name);
}

1;
