package QUERY::Insert;
our $VERSION = '1.0';
our @ISA = qw(QUERY::Query);

use QUERY::Query;
use TOOLS::assert;
use strict;

sub _init {
    my ($self, %params) = @_;

    assert($self->{"_where"}->empty(), "No where clause allowed");

    # Parameters
    $self->{"_table"} = $params{"table"};
    $self->{"_attributes"} = $params{"attributes"};

    # Other attributes
    $self->{"_op"} = "insert";


    my $counter = 1;
    foreach (@{$self->{"_attributes"}}) {
	$self->{"_vars"}->{$_} = [$counter++];
    }
    $self->{"_query"} = $self->create_query();
    return $self;
}

sub create_query {
    my $self = shift;

    return $self->{"_op"}." into ".$self->{"_table"}."(".join(",", @{$self->{"_attributes"}}).") values(".("?,"x(@{$self->{"_attributes"}}-1))."?)";
}


    
