package QUERY::SVSelect;
our $VERSION = '1.0';
our @ISA = qw(QUERY::Select);

use QUERY::Select;
use TOOLS::assert;
use strict;

sub _init {
    my ($self, %params) = @_;

    assert($params{"table"}, "Need a table field parameter\n");
    assert($params{"return_field"}, "Need a return_field parameter\n");
    foreach (values %{$params{"table_hash"}}) {
	@$_ == 0 or die("QUERY::SVSelect::new: Does not take attribute names in the table hash\n");
    }

    $params{"return_field"} =~ s/^(.+)\.//;

    $params{"table_hash"}->{$params{"table"}} = [$params{"return_field"}];

    return $self->QUERY::Select::_init(%params);
}

sub fetch_value {
    my $self = shift;

    $self->{"_open"} or die("QUERY::SVSelect::fetch_value: Not open");
    my $ref = $self->{"_sth"}->fetchrow_arrayref();
    return $ref ? $ref->[0] : undef;
}

sub fetch_values {
    my $self = shift;

    $self->{"_open"} or die("QUERY::SVSelect::fetch_values: Not open");
    my @results;
    while (my $v = $self->fetch_value()) {
	push (@results, $v);
    }
    $self->finish();
    return @results;
}
