package TOOLS::assert;
require Exporter;

our @ISA = qw(Exporter);
our @EXPORT = qw(assert assert_static assert_dynamic assert_dbh assert_abstract);
our $VERSION = '1.0';

sub assert {
    my $condition = $_[0];
    my $msg = $_[1];
    chomp $msg;
    die((caller(1))[3].": ".$msg."\n") unless $condition;
}

sub assert_static {
    my $obj = shift;
    my $fun = shift || (caller(1))[3];
    die($fun.": Only for use as static function\n") if ref($obj);
    return $obj;
}

sub assert_dynamic {
    my $obj = shift;
    my $fun = shift || (caller(1))[3];
    die($fun.": Only for use as Dynamic function") unless ref($obj);
    return $obj;
}

sub assert_dbh {
    my $obj = shift;
    die((caller(1))[3].": database handle undefined\n") unless defined $obj;
    die((caller(1))[3].": Bad database handle: $obj\n") unless ref($obj) eq "DBI::db";
    return $obj;
}

sub assert_where {
    my $obj = shift;
    die((caller(1))[3].": where object undefined\n") unless defined $obj;
    die((caller(1))[3].": Bad where object: $obj\n") unless ref($obj) eq "QUERY::Where";
    return $obj;
}

sub assert_abstract {
    my $class = shift;
    my $calling_class = (caller(0))[0];
    my $caller = (caller(1))[0];
    die($class.": Abstract function, instantiated in $caller\n") if ($class eq $calling_class);
    return $class;
}
