#!/usr/bin/perl -w
package TaxID::tax_id;

use strict;
use TOOLS::genome;
use DB::db;

require Exporter;

our @ISA = qw(Exporter);
our @EXPORT = qw(get_org get_clade get_tax_id get_tax_id_hash get_hash_by_type add_tax_id get_type);
our $VERSION = 1.00;

my $dbh = DB::db::getDB("db" => "TaxID");

sub get_type {
    my $tax_id = shift;
    my $sth = $dbh->prepare("select type from tax_id where tax_id = $tax_id");
    $sth->execute();
    my $ref = $sth->fetchrow_arrayref();

    my $t = $ref->[0] || undef;
    $sth->finish();
    return $t;
} 

sub get_org {
    my $sth = $dbh->prepare("select organism from tax_id where tax_id = $_[0]");
    $sth->execute();
    my $ref = $sth->fetchrow_arrayref();

    return undef unless defined($ref);
    
    my $org = $ref->[0] || undef;
    $sth->finish();
    return $org;
}

sub get_clade {
    my $sth = $dbh->prepare("select clade from tax_id where tax_id = $_[0]");
    $sth->execute();
    my $ref = $sth->fetchrow_arrayref();

    return undef unless defined($ref);
    
    my $org = $ref->[0] || undef;
    $sth->finish();
    return $org;
}

sub get_tax_id {
    my $sth = $dbh->prepare("select tax_id from tax_id where organism = '$_[0]'");
    $sth->execute();
    my $ref = $sth->fetchrow_arrayref();

    return undef unless defined($ref);
    
    my $tid = $ref->[0] || undef;
    $sth->finish();
    return $tid;
}

sub get_tax_id_hash {
    my $direction = shift;  # undef = organism->id;  defined = id->organism

    my $str = $direction ? "tax_id,organism" : "organism,tax_id";
    my $sth = $dbh->prepare("select $str from tax_id");
    $sth->execute();

    my %H;
    while (my $ref = $sth->fetchrow_arrayref()) {
	$H{$ref->[0]} = $ref->[1];
    }

    return %H;
}

sub get_hash_by_type {
    my $type = shift;
    my $direction = shift;  # undef = organism->id;  defined = id->organism

    my $str = $direction ? "tax_id,organism" : "organism,tax_id";
    my $sth = $dbh->prepare("select $str from tax_id where type=\'$type\'");
    $sth->execute();

    my %H;
    while (my $ref = $sth->fetchrow_arrayref()) {
	$H{$ref->[0]} = $ref->[1];
    }

    return %H;
}

# Org. name, tax id
sub add_tax_id {
    assert(@_ == 3);
    my $sth = $dbh->prepare("insert into tax_id(organism, tax_id, type) values('$_[0]', $_[1], $_[2])");
    $sth->execute();
}
