#!/usr/bin/perl -w
use strict;

use DBI;
use CGI qw(:all);

print header();

########################################
#   Display nucleotide sequence
########################################

my $gid = param("gid");
my $sid = param("sid");
my $class = param("class");
my $seq = param("seq");
$class =~ tr/A-Z/a-z/;
my $infile = "master.final.$class.dna";
my $find = 0;
my $dna ='';

if ($seq eq 'dna') {

print "<FONT SIZE='-1' CLASS='sans-serif' FACE='arial, Helvetica'>";
      
&process_n($gid);

print "<TABLE align='left' CELLPADDING='2' cellspacing='2' WIDTH='800' BORDER='0'>",
      "<TR><FONT size = '3pt' color ='green' CLASS='sans-serif' FACE='arial, Helvetica'><B>Nucleotide Sequence:<B></font></tr>";
	  
&display_seq($dna);


############################################
#  Display nucleotide sequence alignment
############################################
print "<tr><br></tr>";
print "<TR><FONT size = '3pt' color ='green' CLASS='sans-serif' FACE='arial, Helvetica'><B>Alignment to CDS Sequence:<B></font></tr>";

$infile = "master.$class.single.clustal.aln.longid";
if ($gid =~ /.*_(.*?)\.(.*)/) {
	$query1 = $1;
}

$find = 0;
$count = 0;
open( IN, $infile ) or die "cannot open $infile\n";

print "<TR><span style=\"font-size:8.0pt;font-family:'Courier New'\";>";

while ( $line = <IN> ) {
        chomp $line;
		
        $line =~ s/\'/ /g ;
		$line =~ s/ /&nbsp;/g;

        if ($find == 0) {
        
			if ($line =~ /(.*?)$query1(.*)/) {
				if ($line =~ /$gid(.*)/) {
					$align = $1;
					$find = 1;
					print $aln.$gid;
					for (my $i =1; $i <16-length($gid);$i++)  {
						print "&nbsp";
					}	                                        
					print $align."<br>";
				
				}
				else {
					$aln = $line."<br>";
					next;
				}

			}
			
		}
		
		else {
			if ($line =~ /^<</) {
				last;
			}
			else {
				if ($line =~ /$gid(.*)/) {
                                        $align = $1;
                                        $find = 1;
                                        print $gid;
                                        for (my $i =1; $i <16-length($gid);$i++)  {
                                                print "&nbsp";
                                        }
                                        print $align."<br>";
				}
				else {
					print $line."<br>";
				}
			}
		}
		
}

close (IN);
print "</span></TR>";
}


############################################
#  Display amino acid sequence alignment
############################################

else {
print "<tr><br></tr>";
print "<TR><FONT size = '3pt' color ='green' CLASS='sans-serif' FACE='arial, Helvetica'><B>Alignment to Functional protein Sequence:<B></font></tr>";

$found = 0;
$line_num = 0;
$infile = "master.final.$class.fa";
open( IN, $infile ) or die "cannot open $infile\n";
while ( $line = <IN> ) {
       chomp $line;
      $line =~ s/\'/ /g ;
      $line =~ s/ /&nbsp;/g;
 
      if ($line =~ /$gid(.*)/) {
		$find = 1;
		next;
      }
		
	  if ($find == 1)  {
		if ($line =~ /^>/) {
			last;
	    }
	    else {
	      if ($line_num == 0) {
			  $func = $line;
		      $line_num++;
	      }
		  else {
			  $pseu = $line;
          }
	   }
	  }
}
close (IN);

print "<p><TR><span style=\"font-size:8.0pt;font-family:'Courier New'\";>";
@func = split //, $func;
@pseu = split //, $pseu;
$num = int @func/80;
foreach $i (0.. $num -1) {
   for ($j= $i* 80; $j < $i * 80 + 79; $j++) {
	   print $func[$j];
   }
   print "<BR>";
   for ($j= $i* 80; $j < $i * 80 + 79; $j++) {
       print $pseu[$j];
   }
   print "<BR><BR>";
}
foreach $j ($num * 80 .. @func -1) {
	print $func[$j]
}
print "<BR>";
foreach $j ($num * 80 .. @func -1) {
	print $pseu[$j]; 
}
print "<BR><BR>";


}
print "</table>";

print "</body></html>";





##########################################################################
#        Subroutines
##########################################################################

sub display_seq {
   $seq = $_[0];
   @seq = split //, $seq;
  
   print "<p><TR><span style=\"font-size:8.0pt;font-family:'Courier New'\";>";
   $num = int @seq/60;
   

   foreach $i (0 .. $num - 1 ) {
	   for ($j= $i * 60; $j< $i * 60 + 59; $j++) {
		   print $seq[$j];
	   }
	   print "<br>";
   }

   foreach $j ($num * 60 .. @seq - 1) {
	   print $seq[$j];
   }

   print "</span></TR>";

}


sub process_n {
    $query = $_[0];
	open( IN, $infile ) or die "cannot open $infile\n";
	while ( $line = <IN> ) {
        chomp $line;

        $line =~ s/\'/ /g ;

        if ($line =~ /$query(.*)/) {
			$find = 1;
			next;
		}
		
		if ($find == 1)  {
			$dna = $line;
			last;
			
		}
	}
	close (IN);
	
}
	
	
