#!/usr/bin/perl -w
use strict;

use DB::db;
use TaxID::tax_id;
use CLASSES::Pseudogene;
use QUERY::query_factory;

my %H = get_tax_id_hash(1);
my @tax_ids = keys %H;

my $prok_total = 0;
my $euk_total = 0;
for my $tax_id (@tax_ids) {
    my $dbh = DB::db::getDB("db" => "Pgenes_$tax_id");
	
    if (get_type($tax_id) eq 'Eukaryote') {
	
	my $query = create_query(type => "SVSelect", dbh=>$dbh, table=>"Pseudogene", return_field=>"source", command=>"group by source");
	$query->execute();
    my @sources = $query->fetch_values();
	
	$query = create_query(type => "SVSelect", dbh=>$dbh, table=>"Pseudogene", return_field=>"ptype", command=>"group by ptype");
	$query->execute();
	my @types = $query->fetch_values();
	
	print get_org($tax_id)." ($tax_id): \n";
	for my $s (@sources) {
	    for my $t (@types) {
		my @arr = CLASSES::Pseudogene->get(dbh=>$dbh, where=>"source='$s' and ptype='$t'");
		$euk_total += @arr;
		print "    $s ($t): ".scalar(@arr)."\n";
	    }
	}
	print "\n";
    }
    else {
	my @arr = CLASSES::Pseudogene->get(dbh=>$dbh);
	$prok_total+= @arr;
    }
}

print "Totals:\n";
print "   Euk: $euk_total\nProk: $prok_total\n";
