#!/usr/bin/perl -w
use strict;
use DB::db;
use CLASSES::PFSet;
use CLASSES::Pseudogene;
use CLASSES::Fragment;
use CLASSES::Build;

my $tax_id = 9606; 
my $dbh = DB::db::getDB(db=>"Pgenes_$tax_id");

my @P = sort cmp_pgenes CLASSES::Pseudogene->get(dbh=>$dbh);

my @tmp = ($P[0]);
for my $P (@P) {
    if ($P->get_chromosome()->get_number() ne $tmp[-1]->get_chromosome()->get_number() || ($tmp[-1]->get_coords())[1] < ($P->get_coords())[0]) {
	if (($tmp[-1]->get_ptype() eq 'Ambiguous' && $P->get_ptype() ne 'Ambiguous') || ($tmp[-1]->get_source() ne "Pseudogene.org" && $P->get_source() eq "Pseudogene.org")) {
	    pop(@tmp);
	}
	push(@tmp, $P);
    }
}

printf("P: %d\nTmp:%d\n", scalar(@P), scalar(@tmp));





sub cmp_pgenes {
    my $diff = $a->get_chromosome()->get_number() cmp $b->get_chromosome->get_number();
    return $diff if $diff;

    my @c1 = $a->get_coords();
    my @c2 = $b->get_coords();
    return $c1[0] <=> $c2[0] || $c1[1] <=> $c2[1];
}
