#!/usr/bin/perl -w
use strict;

use DBI;
use CGI qw(:all);
use CLASSES::Build;
use CLASSES::Chromosome;
use CLASSES::Pseudogene;
use DB::db;

my $temp_dir = "/flatfiles/temp-files";

my $q = new CGI;

my $tax_id = param("tax_id") || 9606;
my $org = param("org") || 'Human';
my $chr_num = param("ch") || 1;
my $method = param("method") || 'View whole chromosome';
my $start = param("start") || 2000000;
my $stop = param("end") || 30000000;

my $dbh = DB::db::getDB(db => "Pgenes_$tax_id");

my $B = CLASSES::Build->current_build($dbh);
my @results;

if ($method eq 'View whole chromosome') {    # Get all pgenes on the chromosome
    $start = 1;
    $stop = undef;
}

my $C = $B->get_chromosome($chr_num);
$start = $start || 1;
@results = CLASSES::Pseudogene->get_by_location($dbh, $C, $start, $stop);

my $length = @results;

#display results
if ($length == 0 ) {
    print $q->header("text/html");
    print $q->start_html("Bad Search");
    print "<FONT SIZE='4pt' CLASS='san-serif' FACE='arial, Helvetica'>";
    print "<p>There are no pseudogenes in this region";
    print "<p><center><A href='./pseudo.cgi'>Go back</A><p>";
    print $q->end_html();
}


else {
    my $t = time();
    my $tmp_file = "$temp_dir/$org.tmp.$t";
    open(OFILE, ">$tmp_file") || die("Can't open file");
    exit(1);
    for my $P (@results) {
	my $id = $P->get_id();
	my $acc = $P->get_acc();
	my $name = $P->pgene_name();
	my $Protein = $P->get_protein();
	my $p_acc = $Protein->get_acc();
	my $p_name = $Protein->get_name();
	my $chr_num = $P->get_chromosome()->get_number();
	my ($start, $stop) = $P->get_coords();
	my $strand = $P->get_strand;
	my $type = ($P->get_ptype() eq 'p') ? 'Processed' : 'Duplicated';
	my @A = $P->get_alignments();
	my ($p_start, $p_stop) = ($A[0]->get_protein_start(), $A[-1]->get_protein_finish());
	my $e_value = (@A==1) ? ($A[0]->get_e_value() || "NULL") : "NA";
	my $aa_identity = (@A == 1) ? ($A[0]->get_aa_ident() || "NULL") : "NA";
	my $polya = $P->get_polya();
	my $disable = $P->get_disable();
	
	my $aa = $P->get_aligned_translation();
	my $dna = $P->get_sequence();
	
	print OFILE "$acc\t$chr_num\t$start\t$stop\t$p_start\t$p_stop\t$e_value\t$aa_identity\t".($polya || 'NULL')."\t".($disable || 'NULL')."<br>";
    }
    close(OFILE);
    #print "<meta http-equiv=\"REFRESH\" content=\"1; URL=/flatfiles/temp-files/$tmp_file\"/>";
 
    print $q->header(),
      $q->start_html("Generating File"),
      "<a href=\"/flatfiles/temp-files/$tmp_file\"/>Click here</a>";
      $q->end_html()
}

