#!/usr/bin/perl 

use strict;
use DB::db;
use TaxID::tax_id;
use Data::Dumper;

my %H = get_tax_id_hash(1);
my @genomes = keys %H;

my @type = ("gtf", "html", "text");

foreach my $genome(@genomes){
	my $dbh2 = DB::db::getDB(db => "Pgenes_$genome");
        next unless (get_type($genome) eq 'Prokaryote');
	my $sth2 = $dbh2->prepare("select id, acc, version from PFSet_Version A, PFSet B where A._acc = B.acc and A._version = B.version");
	$sth2->execute();
	my $sets;
	while (my ($id, $acc, $version) = $sth2->fetchrow_array){
		$sets .= " $id";
	}
	foreach my $t(@type){
		my $command = "./create-cache.v2.pl $genome $t $sets";
		print "$command\n";
		system("$command"); 
	}
	$dbh2->disconnect();
}
