#!/usr/bin/perl -w
use strict;

#=============================================================
# Display list of organisms for selection
#==============================================================
use DB::db;
use TaxID::tax_id;
use CLASSES::Build;
use CGI qw(:all);

my $flatfile_dir = "/flatfiles";

print header();

my $type = param("type") || 'Eukaryote'; #die("No organism type given\n");
my %tax_hash = &get_hash_by_type($type);
my $header_gif = ($type eq 'Eukaryote') ? 'eheader.gif' : 'pheader.gif';

print<<HTMLCODE;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Database Access ($type)</title>
<meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
<style type="text/css">
<!--
.organismtable {
	font-family: "Verdana", "Arial", "Helvetica", "sans-serif";
	font-size: 12px;
	color: #000000;
}

.td1 {
	border: thin solid #999999;
	text-transform: uppercase;
	font-weight: bold;
}
.td2 {
	border: thin solid #000066;
	text-transform: uppercase;
	font-weight: bold;
}
-->
</style>
<style type="text/css">
<!--
a:link {
	color: #000066;
}
a:visited {
	color: #0000FF;
}
-->
</style>
</head>

<body bgcolor="#EEF0F0">
<center>
    <br/>
    <img src="/$header_gif" alt="" />
	<br/>
 
  <table width="1000" class="organismtable" cellspacing="10" cellpadding="3">
HTMLCODE

my $counter = 0;
my @orgs = sort keys %tax_hash;
for my $org (@orgs) {
    my $tax_id = $tax_hash{$org};
    my $td_string = ($counter++ % 2 == 0) ? "td1" : "td2";
    my $org_changed = $org;
    $org_changed =~ s/\s/_/g;
    my $dbh = DB::db::getDB(db => "Pgenes_$tax_id");
    my $build = CLASSES::Build->current_build_number($dbh);

print<<MIDHTML;
    <tr>
    <td class=$td_string>$org</td>
    <td><A HREF="search.cgi?tax_id=$tax_id">Search All Pseudogenes</A></td>
    <td><A HREF="search.cgi?tax_id=$tax_id&search_type=PFSet">Search Pseudogene Sets</A></td> 
    <td><a href="search-results.cgi?all=1&tax_id=$tax_id&sort=1&output=gtf">Pseudogene Flatfile (gtf)</a></td>
    <td><a href="search-results.cgi?all=1&tax_id=$tax_id&sort=1&output=text">Pseudogene Flatfile (txt)</a></td>
    <td><a href="display-genome-files.cgi?tax_id=$tax_id">List Chromosomes</a></td>
   </tr>
MIDHTML
}

print<<ENDHTML;
</table>
</center>

</body>
</html>

ENDHTML
