#!/usr/bin/perl -w
use strict;

#==============================================================================================
# The query page
#==============================================================================================

use DBI;
use CGI qw(:all);
use DB::db;
use CLASSES::Build;
use CLASSES::Pseudogene;

my $info = param("info") || "$ARGV[0]|$ARGV[1]";
my ($org,$tax_id) = split(/\|/, $info);

my $dbh = DB::db::getDB(db => "Pgenes_$tax_id");

my $sample_pgene = (CLASSES::Pseudogene->get(dbh => $dbh, command => "limit 1"))[0];

unless ($sample_pgene) {
    print header();
    print "<P>There are no recorded pseudogenes in the $org database.</P>";
    print end_html();
}

my $build_number = CLASSES::Build->current_build_number($dbh);
my $sample_acc = $sample_pgene->get_acc();
my $sample_pro = CLASSES::Protein->get_primary_acc($dbh, $sample_pgene->get_protein()->get_acc());

print header();

print <<HTML_content; 

 <FONT SIZE='6' SPAN class='h1'><B>$org Pseudogenes Analysis</B></span>
<p><B><FONT SIZE='3pt' CLASS='sans-serif' FACE='arial, Helvetica'>
<!--<A href="javascript:PopUp('../human/help_search.html', 350, 600, 60, 60)" 
	 ONCLICK="PopUp('../../pseudogenes/help_search.html', 350, 600, 60, 60); return true;">Help<a> for this page -->
 <p><TABLE CELLPADDING="2" HEIGHTTH="600" WIDTH="600" CELLSPACING="1" BORDER="0">
 <TR><TD BGCOLOR="#C1C1BB">
 <FONT SIZE="4" CLASS="sans-serif" FACE="arial, Helvetica">
 <B>Display pseudogene ($org: Build $build_number)</B></FONT></TD></TR> 
 
 <TR><TD BGCOLOR="#e3fdfa">
 <FONT SIZE="3" CLASS="sans-serif" FACE="arial, Helvetica">
 <B>Enter an pseudogene accession number or protein accesion number to search for pseudogenes:</B></FONT></TD></TR> 
 <TR><TD BGCOLOR="#F3F3F3">
 <BLOCKQUOTE><FONT SIZE="2" CLASS="sans-serif" FACE="arial, Helvetica">
 
 <FORM METHOD="GET" ACTION="result.cgi" ENCTYPE="application/x-www-form-urlencoded">
 <p> 
 <INPUT TYPE="hidden" NAME="method" VALUE="id"> 
 <INPUT TYPE="hidden" NAME="tax_id" VALUE="$tax_id">
 <INPUT TYPE="hidden" NAME="organism" VALUE="$org">
 



 <INPUT SIZE="20" TYPE="text" NAME="pgene_entry" value="PGO.$tax_id.$sample_acc">&nbsp;&nbsp; 
 
 <INPUT TYPE="submit" NAME="searchgroup" VALUE="Search by pgene accession number">
 </p>
 <p>
 <INPUT SIZE="20" TYPE="text" NAME="protein_entry" value=$sample_pro>&nbsp;&nbsp; 
 <INPUT TYPE="submit" NAME="searchgroup" VALUE="Search by protein accession number">
 </FORM>
 </FONT></BLOCKQUOTE></TD></TR> 
 
 <FORM METHOD="POST" ACTION="chrom.cgi" ENCTYPE="application/x-www-form-urlencoded">
 <TR><TD BGCOLOR="#e3fdfa">
 <FONT SIZE="3" CLASS="sans-serif" FACE="arial, Helvetica">
 <B>Select a region of a chromosome to view:</B></FONT></TD></TR> 
 <TR><TD BGCOLOR="#F3F3F3">
 <BLOCKQUOTE>
 
 <INPUT TYPE="hidden" NAME="tax_id" VALUE="$tax_id">
 <INPUT TYPE="hidden" NAME="org" VALUE="$org">
 <FONT SIZE="2" CLASS="sans-serif" FACE="arial, Helvetica">
 <B>Chromosome</B>
 <SELECT name="ch">

HTML_content

my $B = CLASSES::Build->current_build($dbh);
my @arr = $B->chromosome_numbers();
for (@arr) {
    print "<option value='$_'";
    print " SELECTED" if $_ eq "1";
    print ">$_</option>";
}

print "</SELECT>";
print "<INPUT TYPE='submit' NAME='method' VALUE='View whole chromosome'>";
 
print "<p><B>from</B> ";
print "<INPUT SIZE='12' TYPE='text' NAME='start'> ";
print "<B>to</B><INPUT SIZE='12' TYPE='text' NAME='end'>";
 
print "<INPUT TYPE='submit' NAME='method' VALUE='View region'>";
print "</FORM></BLOCKQUOTE></TD></TR> ";
print "</table>";

print "<p><p>";
print "</body>";


print "</html>";
