#!/usr/bin/perl -w
use strict;
use genome;

my %build28;
my %build34;
for (((1..22),'X','Y')) {
    $build28{$_} = genome->new("build28/chr$_.fa");
    $build34{$_} = genome->new("build34/chr$_.fa");
}

print $build28{'6'}->get_size()."\n";
exit 1;

open(IFILE1, "master.final.pssd1.gtf") or die("master\n");
open(IFILE2, "output.gtf") or die("output\n");
open(OFILE, ">compare.txt");

my ($line1, $line2);
chomp($line2 = <IFILE2>);
while ($line1 = <IFILE1>) {
    chomp $line1;
    next unless ($line1."|".$line2) =~ /transcript_id PG0\.9606\.(\d+)\|.*transcript_id PG0\.9606\.\1$/;
    my $id1 = $1;
    
    my @arr1 = split(/\t/, $line1);
    my @arr2 = split(/\t/, $line2);
    my $chr1 = substr($arr1[0],3,2);
    my $chr2 = substr($arr2[0],3,2);
    
    my ($x1, $y1, $strand1) = @arr1[3,4,6];
    my ($x2, $y2, $strand2) = @arr2[3,4,6];
    
    my $s1 = $build28{$chr1}->get_sequence($x1, $y1-$x1+1);
    my $s2 = ($strand1 eq $strand2) ? $build34{$chr2}->get_sequence($x2, $y2-$x2+1) : $build34{$chr2}->get_reverse_complement($x2, $y2-$x2+1);
    
    unless (defined $s1 && defined $s2) {
	print "undefined: $id1\n";
	next;
    }
    
    $s1 =~ tr/acgt/ACGT/;
    $s2 =~ tr/acgt/ACGT/;
    
   if ($s1 ne $s2) {
       print OFILE "$id1:\n$s1\n$s2\n---------------------------------------------\n";
   }
    
    $line2 = <IFILE2>;
    last unless $line2;
    chomp $line2;
}

