#!/usr/bin/perl -w
use strict;

use DB::db;

my $tax_id = shift;
my $old_build_num = shift || undef;       # Number of old build
my $new_build_num = shift;                 # Number of new build
my $new_build_dir = shift;                 # Directory of new build 
my $chain_file = shift || undef;          # Liftover chain file for remapping
my $org_name = shift;
my $org_type = shift;
my $reset = shift || 0;                    # Reset / create the database

if ($reset) {
   $reset eq 'reset' || die("Bad reset value: $reset"); 
   !$old_build_num || die("Can't reset if giving an old build number");
   !$chain_file || die("Can't reset if given a chain file");
   $org_name || die("Must supply and organism name if resetting");
   $org_type eq 'Prokaryote' || $org_type eq 'Eukaryote' || die("Bad org. type: $org_type");
   system("echo 'drop database if exists Pgenes_$tax_id; create database Pgenes_$tax_id' | mysql -u root");

   my $dbh = DB::db::getDB(db => "TaxID");
   $dbh->prepare("delete from tax_id where tax_id = $tax_id")->execute();
   $dbh->prepare("insert into tax_id(tax_id, organism, type) values($tax_id, '$org_name', '$org_type')")->execute();

   system("rm class-descriptions/*~");
   for (<class-descriptions/*>) {
      system("./create_tables.pl $tax_id $_");
   }
   system("./SEARCH/add-contents.pl $tax_id");
}

system("./pipeline-addition/add_build.pl $new_build_num $tax_id $new_build_dir");
if ($old_build_num) {
   $chain_file || die("Replacing a new build, but no chain file provided for remap");
   system("./remap/remap.pl $old_build_num $new_build_num $chain_file $tax_id");
}
system("cp working.search.cgi search.cgi");

