#!/usr/bin/perl -w
use strict;
use CGI qw(:all);
use DB::db;
use SEARCH::Search;
use TaxID::tax_id;
use CLASSES::Build;
use CLASSES::Pseudogene;
use WEB::require;

my $spinner_limit = 10;   # Maximum number of values on a spinner

############# Start page
print header();

eval {

my $tax_id = param("tax_id") || 9615;
my $search_type = param("search_type") || "Pseudogene";
my $set_search = param("set_search");
my $set_not_define = 0;
$set_not_define = 1 if not defined $set_search;
$set_search = 53 if not defined $set_search and $tax_id == 9606; 

my $dbh = DB::db::getDB(db => "Pgenes_$tax_id") || die("Bad tax. id: $tax_id.|");
my $S = SEARCH::Search->new($dbh);
$S->{_sample_pgene} || die("No pseudogenes listed for organism");

my @R = grep {$_->[1] eq $search_type} $S->extract_searches($search_type);
my @extensions = CLASSES::Pseudogene->get_db_extensions($dbh);
my $org = get_org($tax_id);
my $build_number = CLASSES::Build->current_build_number($dbh);

my $download_area;
my $dir = TOOLS::constants::CACHE_DIR;
############# Create navigations string
##open(IFILE, "navigation.php");
#my $nav_string = "";
#while (<IFILE>) {
#    $nav_string = $nav_string.$_;
#}
#close(IFILE);

my $banner = require_banner();
my $nav_string = require_navigation();

############# Create "sort string"
my $sort_string;
my $print_string;
my $return_type;
my $set_search_str = "";
my $title;

if ($search_type eq "Pseudogene") {
    $sort_string = '<TD> <INPUT TYPE="radio" NAME="sort" VALUE="0"> Accession</TD><TD> <INPUT TYPE="radio" NAME="sort" VALUE="1" CHECKED> Location </TD> <TD> <INPUT TYPE="radio" NAME="sort" VALUE="2"> Protein </TD>';
    $print_string = '<TD><INPUT TYPE="radio" NAME="output" VALUE="html" CHECKED> html output &nbsp</TD><TD><INPUT TYPE="radio" NAME="output" VALUE="text"> text output &nbsp   </TD><TD><INPUT TYPE="radio" NAME="output" VALUE="gtf"> gtf output    </TD>';
    $return_type = "Pseudogenes";
    $set_search_str = "<INPUT TYPE='hidden' NAME='set_search' VALUE='$set_search'>" if $set_search;

    if ($set_search) {
	my $S = CLASSES::PFSet->get_pk($dbh, $set_search);
	$title = "Search Psudogene Set ($org)<BR>Set name: <em>".$S->get_name()."</em>" if $set_not_define == 0;
	$title = "Search Psudogenes in $org, Build $build_number<BR>" if $set_not_define == 1;
	#my $download_html = $dir."/$tax_id.$set_search.html";
	my $download_html = "cache/$tax_id.$set_search.html";
	my $download_gtf = "$dir/$tax_id.$set_search.gtf";
	my $download_text = "$dir/$tax_id.$set_search.text";
	$download_area = "<Table align=center width=658 border=0><TR><TD><a href=\"$download_html\">All Pseudogenes in HTML format  </a></TD><TD><a href=\"$download_text\">All Pseudogenes in TXT format  </a></TD><TD><a href=\"$download_gtf\">All Pseudogenes in GTF format  </a></TD></TR></Table>"
    }
    else {
	$title = "Search Pseudogenes ($org: Build $build_number)";
    }
}
else {
    $sort_string = '<TD> <INPUT TYPE="radio" NAME="sort" VALUE="0" CHECKED> Accession </TD><TD> <INPUT TYPE="radio" NAME="sort" VALUE="1"> Name </TD> <TD> <INPUT TYPE="radio" NAME="sort" VALUE="2"> Notes </TD>';
    $print_string = '<TD><INPUT TYPE="radio" NAME="output" VALUE="html" CHECKED> html output &nbsp</TD><TD><INPUT TYPE="radio" NAME="output" VALUE="text"> text output</TD>';
    $return_type = "Sets";
    $title = "Search Pseudogene Sets ($org)" if $set_not_define == 0 ;
    $title = "Search Pseudogene in $org" if $set_not_define == 1 ;
}




my $form_name = $search_type eq "Pseudogene" ? "search-results.cgi" : "set-results.cgi";

sub create_list {
    my $name = $_[0];
    my @list = @{$_[1]};

    my $str = "";
    for (my $i=0; $i < @list; $i++) {
	$str .= "$name\[$i\] = ".$list[$i].";";
    }

    return $str;
}

################################################
# Create criteria arrays statment
my @criteria;
my @operators;
my @searchValues;
for (@R) {
    my ($name, $search_type, $search_method, $relations, $sample_generate, $value_type, $box_length, $value_table, $value_field) = @$_;
    my @spinner_values;
    if ($search_method =~ /search_extended/) {
	my $str = "select _value from Pseudogene_Extensions where _att_name = '$name' group by _value limit ".($spinner_limit+1);
	my $query = $dbh->prepare($str);

	$query->execute();
	while (my $ref = $query->fetchrow_arrayref()) {
	    push(@spinner_values, $ref->[0]);
	}

	if (@spinner_values > $spinner_limit) {
	    $value_type = 'text';
	    $box_length = 25;
	}
	else {
	    $value_type = 'select';
	}
    }

    push(@criteria, "new Array(\"".$name."\", \"".$search_method."\", \"$value_type\")");

    my @relations = split(/\|/, $relations);
    for my $r (@relations) {
	my @r = split(/\,/, $r);
        $r = 'new Array("'.$r[1].'", "'.$r[0].'")';
    }
    push(@operators, '(new Array('.join(", ", @relations).'))');
   
    $value_type || die("\n\n$name\n");
    if ($value_type eq 'text') {
	my $sample_value;
	if ($search_method =~ /search_extended/) {
	    $sample_value = $sample_generate;
	}
	else {
	    my $generate = "get_$sample_generate";
	    $sample_value = $S->$generate();
	}

	push(@searchValues, "(new Array(new Array(\"\", $box_length, $box_length, \"".$sample_value."\")))");
    }
    else {
	if (@spinner_values == 0) {
	    if ($value_table eq 'function') {
		@spinner_values = $S->$value_field;
	    }
	    else {
		my $str = "select $value_field from $value_table group by $value_field";
		my $query = $dbh->prepare($str);
		$query->execute();
		while (my $ref = $query->fetchrow_arrayref()) {
		    push(@spinner_values, $ref->[0]);
		}
	    }
	}

	if ($name eq 'Source') {   # Hack to make sure pseudogene.org is listed first
	    @spinner_values = ('pseudogene.org', grep {$_ ne 'pseudogene.org'} @spinner_values);
	}
	my @options_arr = map {"new Array(\"$_\", \"$_\")"} @spinner_values;
	my $options_str = join(", ", @options_arr);
	push(@searchValues, "(new Array($options_str))");
    }	
}

my $criteria_str = create_list("criteria", \@criteria);
my $operators_str = create_list("operators", \@operators);
my $searchValues_str = create_list("searchValues", \@searchValues);;

{
print <<HTML_BODY
<HTML>
<HEAD>
	<META HTTP-Equiv="Content-Type" Content="text/html; charset=iso-8859-1">

	<SCRIPT Language="JavaScript" Type="text/javascript">
	<!--
		var criteria = new Array();
                $criteria_str;

		var operators = new Array();
                $operators_str;

		var searchValues = new Array();
                $searchValues_str;

		// The tbody element that contains the controls
		var tbObj;

		// Number of rows added
		var rowCount = 0;

		function changeCriterion(criterionObj, rowCount)
		{
			var criterionObjId = criterionObj.name.substring(9);
			var criterionId = criterionObj.selectedIndex - 1;
			if (criterionId == -1)	// Title: do not change the lists
				return;

			var operatorObj, searchValueObj;
			if (document.getElementById)
			{
				operatorObj = document.getElementById("operator" + criterionObjId);
				searchValueObj = document.getElementById("searchValue" + criterionObjId);
			}
			else if (document.all)
			{
				operatorObj = document.all["operator" + criterionObjId];
				searchValueObj = document.all["searchValue" + criterionObjId];
			}
			else
				return;

			// Remove old operator options
			for (i=0; i<operatorObj.options.length; i++)
				operatorObj.options[i] = null;

			// Add new operator options
			for (i=0; i<operators[criterionId].length; i++)
			{
				var operatorValue = operators[criterionId][i][0];
				var operatorText = operators[criterionId][i][1];
				operatorObj.options[i] = new Option(operatorText, operatorValue);
			}

			// Remove old search value controls
			var andOrObj = operatorObj.nextSibling;
			var tempObj;
			while (andOrObj.type != "radio")
			{
				tempObj = andOrObj;
				andOrObj = andOrObj.nextSibling;
				tempObj.parentNode.removeChild(tempObj);
			}

			// Determine the controls for the search value part
			if (criteria[criterionId][2] == "select")
			{
				// Select box
				var newSearchValueObj = document.createElement("SELECT");
				newSearchValueObj.id = "searchValue" + rowCount; //criterionId;
				newSearchValueObj.name = "searchValue" + rowCount + "_0"; //criterionId;
				for (i=0; i<searchValues[criterionId].length; i++)
				{
					var searchValueValue = searchValues[criterionId][i][0];
					var searchValueText = searchValues[criterionId][i][1];
					newSearchValueObj.options[i] = new Option(searchValueText, searchValueValue);
				}
				andOrObj.parentNode.insertBefore(newSearchValueObj, andOrObj);
			}
			else
			{
				// Text box
				for (i=0; i<searchValues[criterionId].length; i++)
				{
					var searchValueLabel = searchValues[criterionId][i][0];
					var searchValueSize = searchValues[criterionId][i][1];
					var searchValueMaxLength = searchValues[criterionId][i][2];
					var searchValueValue = searchValues[criterionId][i][3];

					var newSearchValueText = document.createTextNode(" " + searchValueLabel + " ");
					andOrObj.parentNode.insertBefore(newSearchValueText, andOrObj);
					var newSearchValueObj = document.createElement("INPUT");
					newSearchValueObj.id = "searchValue" + rowCount + "_" + i; //criterionId + "_" + i;
					newSearchValueObj.name = "searchValue" + rowCount + "_" + i; //criterionId + "_" + i;
					newSearchValueObj.size = searchValueSize;
					newSearchValueObj.maxlength = searchValueMaxLength;
					newSearchValueObj.type = "text";
					newSearchValueObj.value = searchValueValue;
					andOrObj.parentNode.insertBefore(newSearchValueObj, andOrObj);
				}
			}

			// For Netscape 4.x
//			if (document.layers)
//				history.go(0);
		}

		function addRow(criterionObj)
		{
			if (document.getElementById)
				tbObj = document.getElementById("searchTableBody");
			else if (document.all)
				tbObj = document.all["searchTableBody"];

			if (criterionObj != null)
			{
				var criterionObjId = criterionObj.name.substring(9);
				var andOrObj;
				if (document.getElementById)
					andOrObj = document.getElementById("andOr" + criterionObjId);
				else if (document.all)
					andOrObj = document.all["andOr" + criterionObjId];
				else
					return;

				var trObj = andOrObj.parentNode.parentNode;
				if (trObj != tbObj.lastChild)
					return;
			}

			// Create a new row and a new cell for the table
			var newRowObj = tbObj.insertRow(-1);
			var newCellObj = newRowObj.insertCell(-1);

			// Search criterion select box
			var newCriterionObj = document.createElement("SELECT");
			newCriterionObj.id = "criterion" + rowCount;
			newCriterionObj.name = "criterion" + rowCount;
			newCriterionObj.onchange = function() {changeCriterion(newCriterionObj, rowCount-1);};
			newCriterionObj.options[0] = new Option("---Search criterion---", "");
			for (i=0; i<criteria.length; i++)
				newCriterionObj.options[i+1] = new Option(criteria[i][0], criteria[i][1]);
			newCellObj.appendChild(newCriterionObj);

			// Operator select box
			var newOperatorObj = document.createElement("SELECT");
			newOperatorObj.id = "operator" + rowCount;
			newOperatorObj.name = "operator" + rowCount;
			newOperatorObj.options[0] = new Option("---Operator---", "");
			newCellObj.appendChild(newOperatorObj);

			// Search value box (assume to be a select box first)
			var newSearchValueObj = document.createElement("SELECT");
			newSearchValueObj.id = "searchValue" + rowCount;
			newSearchValueObj.name = "searchValue" + rowCount;
			newSearchValueObj.options[0] = new Option("---Search value---", "");
			newCellObj.appendChild(newSearchValueObj);

			// And/Or radio buttons
			var newAndObj = document.createElement("INPUT");
			newAndObj.id = "andOr" + rowCount;
			newAndObj.name = "andOr" + rowCount;
			newAndObj.type = "radio";
			newAndObj.value = "and";
			// The checked statements in the following line are for handling a potential bug of IE
			newAndObj.onclick = function() {newAndObj.checked = true; newOrObj.checked = false; addRow(newCriterionObj);};
			newCellObj.appendChild(newAndObj);
			var newAndText = document.createTextNode(" and ");
			newCellObj.appendChild(newAndText);
			var newOrObj = document.createElement("INPUT");
			newOrObj.id = "andOr" + rowCount;
			newOrObj.name = "andOr" + rowCount;
			newOrObj.type = "radio";
			newOrObj.value = "or";
			newOrObj.onclick = function() {newOrObj.checked = true; newAndObj.checked = false; addRow(newCriterionObj);};
			newCellObj.appendChild(newOrObj);
			var newOrText = document.createTextNode(" or ");
			newCellObj.appendChild(newOrText);

			// Delete button
			if (rowCount != 0)
			{
				var newDeleteObj = document.createElement("INPUT");
				newDeleteObj.type = "button";
				newDeleteObj.value = "Delete";
				newDeleteObj.onclick = function() {deleteRow(newRowObj);};
				newCellObj.appendChild(newDeleteObj);
			}
			rowCount ++;
		}

		function deleteRow(rowObj)
		{
			tbObj.deleteRow(rowObj.rowIndex);
		}
	//-->
	</SCRIPT>

<!-- Jong''s modifications start -->
	<LINK REL="stylesheet" TYPE="text/css" HREF="/pg.css">
<!-- Jong''s modifications end -->

</HEAD>
<BODY LEFTMargin="0" TOPMargin="0" MARGINWIDTH="0" MARGINHEIGHT="0">
<!-- GERSTEIN LAB HEADER BAR -->
<FORM action=http://bioinfo.mbb.yale.edu/genome/search/superlink.cgi method=get>
<TABLE cellSpacing=0 cellPadding=0 width="100%" bgColor=#000077 border=0>
  <TBODY>
  <TR>
    <TD noWrap align=left><A href="http://www.yale.edu/"><IMG height=29 
      alt=Yale 
      src="/images/yale.jpg" 
      width=53 border=0></A> <A href="http://bioinfo.mbb.yale.edu/"><IMG 
      height=29 alt="Gerstein Lab" 
      src="/images/gerstein.jpg" 
      width=139 border=0></A></TD>
  </TR></TBODY></TABLE><br>
</FORM>
<!-- END HEADER BAR -->	  

$banner

$nav_string


<!-- Jong''s modifications start -->

<TABLE WIDTH=658 BORDER=0 ALIGN=CENTER><TR><TD>
<!-- <TABLE CLASS="table02" ALIGN=CENTER><TR><TD ALIGN=CENTER>
    <P CLASS="title5">Title Here</P>
</TD></TR></TABLE>
-->
<BR><BR>

    <FORM Name="searchForm" Action=$form_name Method="get">
    <INPUT TYPE="hidden" NAME="tax_id" VALUE="$tax_id">
    $set_search_str

<!-- <TABLE CLASS="table01" width=100%><TR><D>
<SPAN CLASS = "title3">Warning: Database currently undergoing maintenance, and may hang.  Will be back up and fully operational by 12/10/05</span></table>
<P><P><P>  -->
<TABLE CLASS="table01" width=100%><TR><TD>
<SPAN CLASS="title3">$title</SPAN><BR><BR>
<!-- Jong''s modifications end -->

		<TABLE>
  		<TBODY Id="searchTableBody">
		</TBODY>
		<TFOOT>
		<TR>
			<TD><INPUT Type="submit" Value="Submit Search"></TD>
		</TR>
		<TR>
			<TD><INPUT Type="submit" Name="all" Value="View All $return_type"></TD>
		</TR>
 		</TFOOT>
		</TABLE>
	<SCRIPT Language="JavaScript" Type="text/javascript">
	<!--
		addRow(null);
	//-->
	</SCRIPT>
<!-- Jong''s modifications start -->
</TD></TR></TABLE>
</TD></TR></TABLE>
<!-- Jong''s modifications end -->
<BR><BR>
<TABLE WIDTH=658 BORDER=0 ALIGN=CENTER><TR><TD>
<TABLE CLASS="table01" width=100%><TR><TD>
<SPAN CLASS="title3">Search Options</SPAN><BR><BR>
    <TABLE> 
    <TBODY Id="searchOptions"> </TBODY>
    <TFOOT>
    <TR>
    <TR>
    <TD> Sort by: </td>
    $sort_string
    </TR>
    <TD>Output type: &nbsp </TD>
    $print_string
    </TR>
    </TFOOT>
    </TABLE>
</TABLE>
HTML_BODY
};

if (@extensions > 0 && $search_type eq 'Pseudogene') {
    print '<BR><BR>
	<TABLE CLASS="table01" width=100%<TR><TD>
	<SPAN CLASS="title3">Extra Attributes for Display<BR>(Choose extra attributes for html or text display)</SPAN><BR><BR>';
    for (@extensions) {
	print "<TR><TD><INPUT TYPE=CHECKBOX NAME='$_'> $_</TD></TR>";
    }
    print "</table>";
}
	
print <<HTML_BODY2;
	</FORM>

<BR><BR><BR>
$nav_string
</BODY>
</HTML>
HTML_BODY2
};

if ($@) {
   my $error = $@;
   $error =~ s/\|,*$//;
   print "<BR><BR>";
   print "<FONT SIZE='4' color='red' CLASS='sans-serif' FACE='arial,helvetica'>ERROR: $error</FONT><BR>";
}

print end_html();  

