#!/usr/bin/perl -w
use strict;

use CLASSES::Protein;
use DB::db;

my $tax_id = 9606;
my $dbh = DB::db::getDB("db" => "Pgenes_$tax_id");    
my $seq;
my $fh;

my $count = 0;
open($fh, "tppg/psi-out.txt") || die("Bad file\n");
while (my $line = <$fh>) {
   chomp($line);
   my ($old_name, $acc, $name) = split(/\s+/, $line);

   $seq = <$fh>;
   chomp($seq);

   my $primary = CLASSES::Protein->get_primary_acc($dbh, $acc);
   unless ($primary) {
      print "$count\n";
      $count++;
      CLASSES::Protein->add_secondaries($dbh, $acc, $acc);
      $primary = $acc;
   }

   my $P = CLASSES::Protein->get_by_acc($dbh, $acc);
   if (!$P) {
      $P = CLASSES::Protein->new(dbh=>$dbh, acc=>$primary, sequence=>$seq, tax_id=>$tax_id);
      $P->insert();
   }
   else {
      if ($P->get_sequence() ne $seq) {
        $P->set_sequence($seq);
      }
      if (!$P->get_name() || $P->get_name() ne $name) {
        $P->set_name($seq);
      }
      unless ($P->set_in_db()) {
        $P->insert();
      }
  }
}

