package TOOLS::translate;
use strict;
use TOOLS::assert;
require Exporter;

our @ISA = qw(Exporter);
our @EXPORT = qw(translate);
our $VERSION = 1;

{
    my $init = 0;
    my %codon_dictionary;

    sub translate {
	
	my $str = shift;
	assert(length($str) % 3 == 0, "Cannot translate a string with an incomplete codon\n");
	
	unless ($init) {
	    $init = 1;
	    %codon_dictionary = &codon_dictionary();
	}
	
	my $result = "";
	for (my $i=0; $i < length($str) / 3; $i++) {
	    $result .= $codon_dictionary{substr($str, 3*$i, 3)};
	}
	
	return $result;
    }
}

sub codon_dictionary {
    return (
	    'TCA' => 'S',
	    'TCC' => 'S',
	    'TCG' => 'S',
	    'TCT' => 'S',
	    'TTC' => 'F',
	    'TTT' => 'F',
	    'TTA' => 'L',
	    'TTG' => 'L',
	    'TAC' => 'Y',
	    'TAT' => 'Y',
	    'TAA' => '*',
	    'TAG' => '*',
	    'TGC' => 'C',
	    'TGT' => 'C',
	    'TGA' => '*',
	    'TGG' => 'W',
	    'CTA' => 'L',
	    'CTC' => 'L',
	    'CTG' => 'L',
	    'CTT' => 'L',
	    'CCA' => 'P',
	    'CCC' => 'P',
	    'CCG' => 'P',
	    'CCT' => 'P',
	    'CAC' => 'H',
	    'CAT' => 'H',
	    'CAA' => 'Q',
	    'CAG' => 'Q',
	    'CGA' => 'R',
	    'CGC' => 'R',
	    'CGG' => 'R',
	    'CGT' => 'R',
	    'ATA' => 'I',
	    'ATC' => 'I',
	    'ATT' => 'I',
	    'ATG' => 'M',
	    'ACA' => 'T',
	    'ACC' => 'T',
	    'ACG' => 'T',
	    'ACT' => 'T',
	    'AAC' => 'N',
	    'AAT' => 'N',
	    'AAA' => 'K',
	    'AAG' => 'K',
	    'AGC' => 'S',
	    'AGT' => 'S',
	    'AGA' => 'R',
	    'AGG' => 'R',
	    'GTA' => 'V',
	    'GTC' => 'V',
	    'GTG' => 'V',
	    'GTT' => 'V',
	    'GCA' => 'A',
	    'GCC' => 'A',
	    'GCG' => 'A',
	    'GCT' => 'A',
	    'GAC' => 'D',
	    'GAT' => 'D',
	    'GAA' => 'E',
	    'GAG' => 'E',
	    'GGA' => 'G',
	    'GGC' => 'G',
	    'GGG' => 'G',
	    'GGT' => 'G');
}

1;
