#!/usr/bin/perl -w
use strict;

#=============================================================
# Display list of organism
#==============================================================
use DB::db;
use CGI qw(:all);
use CLASSES::Build;

print header();

my $tax_id = param("tax_id") || die("No organism tax id given.", end_html());
my $dbh = DB::db::getDB(db => "Pgenes_$tax_id") || die("Bad organism tax id given", end_html()); 

my $Build = CLASSES::Build->current_build($dbh);
my $dir = $Build->get_directory();
$dir =~ s/^.*cgi-bin//;
my @chrs = $Build->chromosome_numbers();

print "<FONT SIZE='4' color='green' CLASS='sans-serif' FACE='arial, Helvetica'>\n",
    "<center><span class='h1'><B>Genome Files (FASTA format)</B></span></center>\n";
print "<TABLE align='center' CELLPADDING='2' WIDTH='400' CELLSPACING='1' BORDER='1'><TR align='center' BGCOLOR='#e3fdfa'>";
print "<td><B><font size='-1' face=\"sans-serif,helvetica,arial\">Chromosome</font></B></td>\n\n";

my $counter = 0;
for my $chr (@chrs) {
    my $C = $Build->get_chromosome($chr);
    my $file = $C->get_file_name();
    my $color = ($counter % 2 == 0) ? "#F3F3F3" : "#E2E2E2";
    $counter++;

    print "<TR align='left' BGCOLOR='$color'>\n";
    print "<TD><CENTER><font size='-1'><A HREF=\"$dir$file\">Chromosome $chr</A></font></CENTER></TD>\n\n";
}

print "</TABLE>\n";

print end_html(), "\n";
