#!/usr/bin/perl -w
use strict;

#=============================================================
# Display functional gene information
#==============================================================
use DB::db;
use CLASSES::Pseudogene;
use CGI qw(:all);

print header();

my @arr = split(/\|/, params("list"));
my $tax_id = param("tax_id") || '272557';
my $org = param("organism") || 'BBB';

my $dbh = DB::db::getDB(db => "Pgenes_$tax_id");
	
my @results;
for (@arr) {
    push(@results, CLASSES::Protein->get_pk($_));
}

my $length = @results;
if ($length == 0 ) { 
    print "<FONT SIZE='4pt' CLASS='sans-serif' FACE='arial, Helvetica'>";
    print "<p>There are no current matches for $input.<p>";
    print "<p><center><A href='./pseudo.cgi'>Go back</A><p><html>";
    
}
else {
    print "<FONT SIZE='-1' color ='green' CLASS='sans-serif' FACE='arial, Helvetica'>",
    "<P><IMG border ='0' src = '../human/yellowdot.gif'>Click on the yellow button to view amino acid sequence.</font>",
    
    "<FONT SIZE='3pt' color='blue' CLASS='sans-serif' FACE='arial, Helvetica'><P>Click on the Pgene ACC to view the corresponding pseudogene annotation.</p>",
    
    "</FONT></center><hr>";	

    my @attributes = ("Protein ACC", "Name");
    print "<TABLE align='center' CELLPADDING='2' WIDTH='1200' CELLSPACING='1' BORDER='1'><TR align='center' BGCOLOR='#e3fdfa'>";
    
    # print the table header
    foreach my $aa (@attributes) {
	print "<td><B><font size='-1' face=\"sans-serif,helvetica,arial\">$aa</font></td>\n";
    }
    
    for my $P (@results) {

	my $id = $P->get_id();
	my $acc = $P->get_acc();
	my $name = $P->pgene_name();
	my $chr_num = $P->get_chromosome()->get_number();
	my ($start, $stop) = $P->get_coords();
	my $strand = $P->get_strand();
	my $type = ($P->get_ptype() eq 'p') ? 'Processed' : 'Duplicated';
	my $protein_acc = $P->get_protein()->get_acc();
	my $protein_name = $P->get_protein()->get_name();
	my $dna = $P->get_sequence();
	my $aa = $P->get_aligned_translation();

	print "<TR align='center' BGCOLOR='#F3F3F3'>";
	
	# display the links to sequence information

	
	print "<TD><A href='dna_pr_display.cgi?c_type=nucleotide&acc=$acc&seq=$dna' target='_new'>",
	"<img border='0' src='../human/reddot.gif'></A>",
	"<A href='dna_pr_display.cgi?c_type=amino_acid&acc=$acc&seq=$aa' target='_new'>", 
	"<img width='12' border='0' src='../human/yellowdot.gif'></A></TD>";
	
	# display the table 

	
	print "<TD><font size='-1'><A href='pgene.cgi?id=$id?tax_id=$tax_id?organism=$org' target='_new'>$acc</font></TD>",
	"<TD><font size='-1'>$name</font></TD>",
	"<TD><font size='-1'>$chr_num</font></TD>",
	"<TD><font size='-1'>$start</font></TD>",
	"<TD><font size='-1'>$stop</font></TD>",
	"<TD><font size='-1'>$strand</font></TD>",
	"<TD><font size='-1'>$type</font></TD>",
	"<TD><font size='-1'>$protein_acc</font></TD>",
	"<TD><font size='-1'>$protein_name</font></TD>",
	"<TD><table>";
	print "</TABLE></TD>",
    }
    print "<table>";
    
}

print "<FONT SIZE='3pt' CLASS='sans-serif' FACE='arial, Helvetica'>",
    "<p><p><center><A href=\"javascript:PopUp('../human/help_result.html', 800, 600, 60, 60)\" ONCLICK=\"PopUp('../human/help_report.html', 1000, 600, 60, 60); return true;\">Help</A> for this page</center>",
    "</FONT></body></html>";


