#!/usr/bin/perl -w
use strict;

use CLASSES::Protein;
use DB::db;
use Data::Dumper;
######################### (parameters)
my $tax_id = $ARGV[0] || 9606;    # tax_id of organism being updated
my $file = $ARGV[1] || "../data/human/build34/proteins2/Homo_sapiens.NCBI34.sep.pep.fa"; #"/data/home/karro/mysql/data/chicken/prot/Gallus_gallus.WASHUC1.sep.pep.fa"; # Ensembl listings of proteins
my $reset_tables = $ARGV[3] || undef; # || 'reset';
die("Bad reset table value: $reset_tables\n") unless !$reset_tables || ($reset_tables eq 'reset');

######################### (remove)
if ($reset_tables) {
   system("/data/home/karro/mysql/project/create_tables.pl $tax_id class-descriptions/Protein.cl");
   system("/data/home/karro/mysql/project/create_tables.pl $tax_id class-descriptions/protein-table.tbl");
   system("/data/home/karro/mysql/project/create_tables.pl $tax_id class-descriptions/protein_version.tbl");
}

main(@ARGV);
sub main {
    my $dbh = DB::db::getDB("db" => "Pgenes_$tax_id");    

    open(IFILE, $file);

    my $line = <IFILE>;
    chomp($line);
    while (1) {
	my @arr = ();
	my ($pacc, $gid) = $line =~ /^\>([^\s]+).*gene:(\w*)/;  ($pacc && $gid) || die("Line dosn't parse: $_\n");
        my $primary = CLASSES::Protein->get_primary_acc($dbh, $pacc);

	if (!$primary) {
	   CLASSES::Protein->add_secondaries($dbh, $pacc, $pacc);
	   $primary = $pacc;
  	}
	# Need to quit if the protein hasn't changed
	
	my $seq = "";
	while ($line = <IFILE> ) {
	   chomp($line);
	   last if substr($line, 0, 1) eq ">";
	   $seq .= $line;
	}

	my $P = CLASSES::Protein->get_by_acc($dbh, $pacc); 
        if ($P) {
	   if ($P->get_sequence() ne $seq) {
              $P->set_sequence($seq);
           }
           if (!$P->get_gene_id() || $P->get_gene_id() ne $gid) {
              $P->set_gene_id($gid);
           }
 	   if (!$P->set_in_db()) {	
	      $P->insert();
           }
        }
        else {
	   my $protein = CLASSES::Protein->new("dbh"=>$dbh, "acc" => $primary, "sequence" => $seq, "tax_id" => $tax_id, "gene_id" => $gid);
           #print &Dumper($protein);
	   $protein->insert();
        }
        
	last unless defined($line);
    }
}
